# Excel 連携 『SS7』の計算結果一覧をシートに表示

## 本プログラムの説明
Python のライブラリは豊富で、Excel と連携できるものもあります。そのライブラリ（xlwings）と『Op.Python 実行』を利用することで、Excel 上の操作のみで『SS7』を起動することなく『SS7』のデータを読み込みが可能になります。


![Excel連携の概要](docs/image/flow_excel_ss7.png)


このサンプルでは、Excelのシートに記載しているフォルダと『SS7』のバージョンを読み、フォルダ内に存在する指定バージョンの『SS7』データの計算結果をExcelのシートに出力します。<BR>
<BR>

## 本プログラムの実行方法
マクロが組み込まれているExcelファイル（SS7結果一覧.xlsm）の[結果一覧の表示]ボタンがあるシートで、以下のように設定します。<BR>
B1セル：SS7データが格納されているフォルダのパスを入力してください。<BR>
B2セル：SS7のバージョン を選択してください。<BR>

![Excelシート](docs/image/excel_sheet.png)

[結果一覧の表示]ボタンをクリックすることで、Pythonの関数を実行するマクロを実行します。<BR>
指定したフォルダに指定したバージョンのデータがあれば、D5セルに「SS7データがみつかりました。」、D6セルにデータ数，結果総数が表示され、10行目以降に『SS7』データと計算結果（検定比の最大値、Qu/Qunの最小値）が表示されます。検定比およびQu/Qunは、ケース・方向・階・部材すべての最大または最小を抽出します。<BR>
指定したフォルダに指定したバージョンのデータがなければ、D5セルに「SS7データがみつかりませんでした。」が表示されます。<BR>
<BR>

## 注意事項
結果ひとつに対し2秒程の時間を要します。<BR>
<BR>

## 『Op.Python実行』の設定手順
Ss7Pythonライブラリを使用するための設定手順です。
1. 『SS7』を起動し，[ツール－環境設定－Op.Python実行]画面を表示します。
2. “利用可能なPython言語のバージョン”を選択し，[デスクトップへコピー]ボタンをクリックします。
3. デスクトップにある「Python」フォルダごと，「src」フォルダにコピーします。

## 必要な外部ライブラリ
以下の外部ライブラリをPython実行環境にインストールしてください。
- xlwings 0.29.1

```cmd
pip install xlwings
```
外部ライブラリのライセンスは「LICENSES/ライセンスについて.txt」を確認してください。<BR>
xlwingsについて、アドイン設定も必要です。詳しくは [xlwingsアドイン設定.pdf](docs/xlwingsアドイン設定.pdf) を参照してください。<BR>


## 著作者
Copyright (C) 2024 UNION SYSTEM Inc.


## ライセンス
本プログラムは MIT License に基づいています。「LICENSE」を確認してください。

